NoGap Sample App
=============

This `Sample App` uses Angular + Bootstrap + Font-Awsome + `NoGap` for a simple single-page web application.

IMPORTANT: None of those front-end libraries are required to use NoGap. NoGap's only hard-coded dependency is NodeJs for now, but even that dependecy will be removed in the near future.

This app showcases some of the major features of the `NoGap` framework, including:

* Simplicity + Code sharing
  * Client + Host parts of the application can be developed in unison, without having to define a complex protocol or packet routing.
  * You can easily define a `component` that has host-only code, client-only code, and shared code, or any combination thereof.
* Host<->Client RPC
  * You can directly call methods, with arguments, on the other side.
  * But don't worry. It is also secure. The client side does not get to see any of the host code.
  * At the same time, the stack traces generated by client components 100% accurately report the correct line number and filename.
* Dynamic loading of client-side code
  * The client will only install the components that you want it to and when you want it to.
* Basic asset management
  * You can easily get access to the contents of, or automatically include, files from the local or a designated public folder
   * You can just declare a filename or path as asset, and its contents will be available on the client through the `asset` property.


1. Getting started:
    * `npm install nogap`
    * `cd sample_app`
    * `npm install`
    * `npm start`
2. Connect to the test app
3. Done!